# h2odragon's X4 Foundations Notes

Information and links to facilitate the enjoyment of the game.

+ [Communications](#communications)
+ [Mods](#mods)
+ [Hacking References](#hacking-references)
  + [Tools](#tools)
  + [XMLpatch](#xmlpatch)
  + [Publishing on Steam](#publishing-on-steam)
+ [Hacking Notes](#hacking-notes)
+ [Gameplay References](#gameplay-references)
+ [Gameplay Tips](#gameplay-tips)


This repo may contain anything else useful I thought to throw here as
a reference.



---------------------
## Communications
  
+ [EGOSOFT X4 English
  forum](https://forum.egosoft.com/viewforum.php?f=146) - see also
  [EGOSOFT Forums](https://forum.egosoft.com/index.php) for all
  languages and games

+ [EGOSOFT Discord Server](https://discord.gg/kjUG5P5)

+ [X4F Scripts and modding forum](https://forum.egosoft.com/viewforum.php?f=181)

+ [X4F Reddit](https://www.reddit.com/r/X4Foundations/) - "worth playing yet?"

+ [EGOSOFT X4 Wiki](https://www.egosoft.com:8444/confluence/display/X4WIKI/X4+Wiki+Home)


  
---------------------
## Mods

+ [EGOSOFT Mods
  Sticky](https://forum.egosoft.com/viewtopic.php?f=181&t=410888) -
  and also see the [full board](https://forum.egosoft.com/viewforum.php?f=181)

+ [Steam Workshop](https://steamcommunity.com/app/392160/workshop/)

+ [Nexus Mods](https://www.nexusmods.com/x4foundations)

+ [h2odragon's X4F mods](https://github.com/h2odragon/x4f-notes/blob/master/NEWS.md)

---------------------
## Hacking References

+ [HOWTO-hackx4f](HOWTO-hackx4f.md) - my own blather and linkdump


+ [X Rebirth Mission Director
  Guide](https://www.egosoft.com:8444/confluence/display/XRWIKI/Mission+Director+Guide) -
  syntax and language details

+ [X Rebirth Official
  Tools](https://forum.egosoft.com/viewtopic.php?t=363625) - Also
  discusses aiscripts and what can be done with patch nodes for making
  old saves work with aiscripts that changed.

+ [Breaking Changes
  page](https://www.egosoft.com:8444/confluence/display/X4WIKI/Breaking+Changes) -
  3.0b1? really?

+ [Public Beta feedback
forum](https://forum.egosoft.com/viewforum.php?f=192)


+ [Tools, Tutorials and Resources forum
   thread](https://forum.egosoft.com/viewtopic.php?f=181&t=402382)
   
+ [Getting Started forum thread](https://forum.egosoft.com/viewtopic.php?f=181&t=402452)

+ [enenra's x4modding
  wiki](https://github.com/enenra/x4modding/wiki) - interesting pages
  on [ship
  creation](https://github.com/enenra/x4modding/wiki/3d-Ship-Tut-%28Temp%29)
  and [universe
  creation](https://github.com/enenra/x4modding/wiki/Universe-Creation)
  

+ [Job editor in the libraries
  folder](https://forum.egosoft.com/viewtopic.php?f=181&t=404835) - nifty

+ [TPWar Mod
  tools](https://forum.egosoft.com/viewtopic.php?f=181&t=416933) -
  tools for and some notes on mod development

 + [Reload AI/MD scripts in
   game](https://forum.egosoft.com/viewtopic.php?f=181&t=407062) - The
   binary contains strings for these commands, "aicompat" which might
   be like the[XR Command Line](https://forum.egosoft.com/viewtopic.php?t=366657), and
   "thereshallbewings"
   

+ [BrummBear's Building your own ship for
  dummies](https://forum.egosoft.com/viewtopic.php?f=181&t=414274) - detailed!

----------------------
### Tools

+ [X Catalog tool
  1.11](https://www.egosoft.com/download/x4/bonus_en.php?download=598) -
  .CAT unpacker. Requires you register your game with the EGOSOFT site
  to download. There's also
  [XERCES](https://www.nexusmods.com/xrebirth/mods/342), which doesn't
  require registration, and has clicky.


+ [Howto use VSCode to edit X4
  scripts](https://forum.egosoft.com/viewtopic.php?t=408087) - For
  those who do not know Emacs. also
  [code completion for x4
  variables](https://github.com/Cgettys/X4CodeComplete/releases) and
  [instructions for using](https://forum.egosoft.com/viewtopic.php?f=181&t=416621)

    + Those who do know emacs and want code completion [might find joy
      here](http://lgfang.github.io/mynotes/emacs/emacs-xml.html) but
      you will have to reprocess the
      XSD's. [This](https://martinfowler.com/articles/emacs-nxml-completion.html)
      could be of use too, typing that extra `="` can be a pain.


+ [X4FProjector](https://github.com/bno1/X4FProjector) - "A command
  line tool that extracts raw stats about various game objects into
  human readable formats"
  
+ [ratilicus github repo](https://github.com/ratilicus/x4)


+ The `makewares.py` file in this repo contains my python text
  processing hacks which generated the quickbuilder mod's data, as
  well as the [TrueNames](trunames/) lists.
  


--------------------
### XMLpatch

+ [XML Patch
  Guide](https://forum.egosoft.com/viewtopic.php?t=354310) - mentions
  [XR modding
  guide](https://forum.egosoft.com/viewtopic.php?t=347831), which is
  similar enough to help.
  
+ [XR Wiki XMLpatch page](https://www.egosoft.com:8444/confluence/display/XRWIKI/Module+2%3A+XML)

+ [RFC 5261: XMLPatch](https://tools.ietf.org/html/rfc5261)


---------------------
### Publishing on Steam

+ [Steam Workshop for XR and
  X4](https://www.egosoft.com:8444/confluence/display/XRWIKI/Steam+Workshop+for+X+Rebirth+and+X4) -
  How do I publish my mod on Steam?
 
+ [Steam X4 Workshop reference
  page](https://steamcommunity.com/sharedfiles/filedetails/?id=245117855) -
  Steam's page for publishing X4 mods, with comments

- [WorkshopTool Help text](WorkshopTool-help.txt)


---------------------
### Other

---------------------
## Hacking Notes

+ the [True Names](truenames/warestag) (ware `id` attributes) by tag from `wares.xml` (v2.50):
  - [All Ware Names](truenames/allwares.txt)
  - [Container Wares](truenames/warestag/container.txt)
  - [Mineable Wares](truenames/warestag/minable.txt)
  - [Modules](truenames/warestag/modules.txt)
  - [Ships](truenames/warestag/ship.txt)
  - [Equipment](truenames/warestag/equipment.txt)
  - [Inventory](truenames/warestag/inventory.txt)
  - [Research](truenames/warestag/research.txt)


+ [Ships Connections](truenames/ship-connections-all.txt) is a list,
  for every ship, of all the connections names and flags.



*******************************************************************

---------------------
## Gameplay References

+ [X4 Official
  Manual](https://www.egosoft.com:8444/confluence/display/X4WIKI/X4%3A+Foundations+Manual) -
  How do I do *anything?*

+ [Official
  FAQ](https://www.egosoft.com:8444/confluence/display/X4WIKI/FAQ)
  
+ [Economy Flow
  Charts](https://www.egosoft.com:8444/confluence/display/X4WIKI/Economy+Flow+Charts) - What ware goes where?

+ [Production Module
  stats](https://www.egosoft.com:8444/confluence/display/X4WIKI/Production+Modules) - Which plant makes what using which?
  

+ [Sectors and their
  resources](https://www.egosoft.com:8444/confluence/display/X4WIKI/Sectors)
 

+ [Missile data](https://gist.github.com/NodusCursorius/fca3a0674ee23264044960d73eefb4a4)


+ [The Peoples of the X Universe](X-Orgs.txt) - Thanks to Herman2000
  via mewosmith
  


---------------------
## Gameplay Tips
  
+ There's an Advanced Orders tab. It allows access to more orders and
  more options on all orders, as well as the ability to queue multiple
  orders at once. [Forum
  Thread](https://forum.egosoft.com/viewtopic.php?f=181&t=417499)
  pointed out by @mewosmith
  
  To access: configure a control to open the chat window, open it,
  enter `/thereshallbewings`, close it. This is a 'controls' type
  setting which will persist across restarts and new games.

+ You can rename ships. Click the name twice in the "Information"
  window and it becomes editable. 
![](pix/rename-ship.png)

+ Stations can be renamed in the 'Plan Build' / 'Station
  Configuration' Screen by clicking the name at the top.

+ [HOWTO add your own ship logo](https://forum.egosoft.com/viewtopic.php?t=402505)

+ SHIFT or CTRL + mouseclick to select multiple ships on
  the property list. Useful when assigning multiple ships to a
  commander. 
  
+ [Docking manually and with
  computer](https://www.egosoft.com:8444/confluence/display/X4WIKI/Docking%2C+and+Using+The+Docking+Computer)
  
  
+ Satellites can be collected. You have to fly to within 400m of it,
  target it, right-click on the map, and a "deactivate" option is
  available. after the satellite is deactivated it can be collected
  by flying into it. Or you could use the *CollectDeployables* command
  in [DragonCommands](https://github.com/h2odragon/dragoncommands)
  
+ [The Captain's
  Ledger](https://forum.egosoft.com/viewtopic.php?t=405825) - How to
  make money pirating; hacking station cargoes, black marketers, etc.
  
+ With the 2.5 release, the speed at which shipyards build ships is no
  longer coupled to populations, but to the number of build drones
  present on the station. More build drones == faster build times.
  
